# Links

-[PokéWorld on the Steam Workshop](https://steamcommunity.com/sharedfiles/filedetails/?id=2652029657)

-GitHub repo containing the data and scripts to generate all 493 Pokémon defs: https://github.com/Gargamiel/PokeWorld_Scripts

# PokéWorld

PokéWorld adds all 493 species of Pokémon from the first four generations to RimWorld, each with their own unique characteristics akin to the original games.

Try and catch as many of these Pokémon as you can to fill up your Pokédex, battle against other wild Pokémon and raiders to gain experience and level up your Pokémon, who will learn more powerfull moves and eventually evolve to grow ever stronger!

Unlike your vanilla RimWorld animal, Pokémon can't be tamed by simply having your colonist walk up to them. Instead, you'll need to use specially crafted Poké Ball belts to catch these Pokémon. But be carefull! Most of them wont let themselves be caught without a fight!  
Once caught, you can choose to assign your new Pokémon to a colonist whom it will follow and protect, and give him orders like a regular drafted pawn while in the vicinity of his master. Or you can chose to let him rest in his Poké Ball until he is later needed.

Pokémon aren't the only addition this mod adds to RimWorld. Keep your eyes wide open when mining in the dark caves, for you might stumble onto treasure among the rocks, such as rare evolution stones, or, even rarer, ancient fossils buried deep for eons. Who knows, with the right tools, you might be able to bring these fossil back to life.

Once you start learning more and more about these strange creatures by filling your Pokédex, you'll eventually find yourself on the track of exceptionally powerful Pokémon, only ever heard of in myths and legends.

Finally, altough it is only just a rumour, it is said amongst the ancient tribes living on this planet that some individual Pokémon can show a very rare coloration, similar to the shine of a bright midnight star.

## Features

- 493 new creatures, all Pokémon from generation I-IV with working mechanics such as leveling, evolution, moves, type effectiveness, breeding, happiness, forms and shiny variations.

- 120 Pokémon moves, 65 melee (physical) and 55 ranged (special). A Pokémon learns new moves when leveling up, and you can chose wich moves to let them uses based on type, power and range. If no other moves are available for a Pokémon, he will default to Struggle.

- A lot of Pokémon themed items, including 7 Fossils, 5 types of Poké Ball belts used to catch Pokémon, 8 Evolution stones, 3 tiers of potions, Rare Candy and every available Pokémon Eggs.

- 2 new buildings: the Pokémon resurrector, a workbench able to bring fossils back to life, and the Portable Computer, which can access the Pokémon Storage System to store up to a thousand Pokémon.

- New or reworked events and incidents, such as manhunter Pokémon packs and infestations.

- 11 research projects.

- A Pokédex tab to keep track of your Pokémon collection.

- More than 30 Legendaries quests.

Since the main Pokémon games and RimWorld are quite different, I had to take some creative liberties in order to implements items or mechanics in a way that would be enjoyable in RimWorld while still beeing faithfull to the original game. Some evolutions requirement in this mod are therefore different than the original ones, trade based evolutions in particular have other requirements, and some item based evolution may not need the exact stone you'd expect, in order to reduce the clutter of unused stones in your stockpile (the Dawn Stone, for example, affects the evolution of only two Pokémon in gen. 4, I therefore removed it and these two now have different requirement to evolve). On the other hand, I have fixed some odd things like Nidorina/Nidoqueen egg group or male Gardevoir.

## Mod options

A slider allows you to set the proportions of Pokémon found in the world over other vanilla or modded animals. If you set this slider to the max (only Pokémon) you will only encounter Pokémon for the whole game, without other creatures breaking the immersion.

Generation selection: You can choose which generation of Pokémon you want your game to feature. You can change it at anytime during play, already existing Pokémon will not disappear.

## Compatibility

### Adding / Removing from existing saves

Adding or removing PokéWorld from an existing save should be safe, but backup and do so at your own risk. Note that removing this mod from a save will remove all your Pokémon and all Pokémon related stuff.

### Royalty & Ideology

There appears to be no big issues.

### Other Mods

**Combat Extended**: It apparently works fine.

**Other Pokémon mod**: No.

**Giddy-up!, animals bionics and other animals QoL mods**: Maybe, Pokémon control when battling is handled in this mod, so there might be compatibility issues with others. As for bionics, it may work for some Pokémon but not all, hopefully we can make patches for that, because who wouldn't want Pokémon with bionics or laser eyes?

**Mods with new biomes**: No, custom biomes will not feature any Pokémon, need to patch these biomes to add Pokémon spawn rates.

Information about other mods will be added based on tests and feedback from the community. If patches are made available i will also link to them here.

## Translation

If you are a translator, feel free to create a patch (try to respect your respective language grammar conventions and syntax regarding the Pokémon media), I'll add them here.

Spanish translation by Imgginspace: https://steamcommunity.com/sharedfiles/filedetails/?id=2653551899

## Q&A

**How do I tame a Pokémon?**: Pokémon aren't tamed the same way vanilla RimWorld animals are. To catch a Pokémon, you need to equip one of your pawn with a Poké Ball belt, draft him and throw Poké Balls at a Pokémon in the hope of catching it. Some Pokémon are easier to catch than other, and weakened Pokémon are more likelly to be caught.

**Why won't my Pokémon fight?**: Make sure your Pokémon has his "Guard" trainability trained, is assigned a master and is set to follow his master while drafted. When selecting this Pokémon while his master is drafted, you will notice a blue circle aroud the master. The Pokémon can then be freely controlled like a normal pawn in this area. Stronger Pokémon master (with higher "animals" skill) have a larger area.

**How many Pokémon can I have at the same time?**: You can battle with as much Pokémon as you want, the sky is the limit. Any Pokémon you don't need/want can be stored in his Poké Ball or in the PC if you don't want to clutter your storage space.

**Do I need another mod to control my Pokémon?**: No, PokéWorld comes with a built-in Pokémon control mechanic.

**Will more Pokémon be added in the future?**: Maybe, if a lot of people request it. It wouldn't be very hard, the main difficulty is to handle Pokémon with unique features (Pokémon with forms or those like Nincada / Ditto) to make them feel unique. There is no point in having 1000 different Pokémon if they all behave the same. I would also need to find sprites for each Pokémon.

**Can I play with only x Pokémon / x generation?**: Yes, in the mod options, you can choose which generation of Pokémon you want your game to feature. You can change it at anytime during play, already existing Pokémon will not disappear. There might be rare cases where a Pokémon from a generation not selected shows up, but it wont pose any issue, feel free to kill and eat it and pretend like nothing happened. The main problem not handled with this system is related to Pokémon evolutionnary lines spread over several generations, and eggs. If for example you select only gen 1, Pikachu will still lay Pichu eggs. Some Pokémon might also be unobtainable in some cases, like Regigigas that require you to have registered the golem trio in your Pokédex. If you only play with gen 4 you wont see the trio and Regigigas quest will never trigger.

**Did you draw each of the Pokémon textures yourself?**: No, there is more than 3000 sprites in total (493 Pokémon x 3 orientation for regular and shiny variation, not accounting forms or gender differences). I used existing ressources (HeartGold & SoulSilver overworld sprites, reason for which there's only the first four generations) and a bit of image manipulation (XBR smooth scaling) to make them more RimWorld friendly. Credit to Larryturbo on DevianArt for some missing textures.

**Can I use ressources from this mod for my own project?**: Of course, but credit would be appreciated.

## Known Issues

- Missing some textures, like Sunshine Cherrim or Fairy Arceus (Regular textures are displayed instead).

- Some Pokémon do not have any unlockable moves.

- Some very specific features like Ditto's transform and Smeargle's sketch aren't implemented (yet).

## What's next?

This is a list of features that may or may not be added based on players interest and feedback.

- Fixing bugs and improving compatibility.

- Improving Legendary Pokémon quests, make them more challenging, with weather event for exemple, and adding proper lore linked with the RimWorld universe for each Legendary.

- Adding more moves, moves effect and animation, such as thunder dropping when using Thunder / Thunderbolt, have a meteor fall when using Draco Meteor, explosions, have dark/ghost-type moves reduce pawns mood, status moves, a TM-like mechanic.

- Improve forms, change type and move set in addition to texture.

- Pokémon themed Pawn backstories and traits.

- Pokémon themed music.

- More Pokémon?

# Disclaimer

This mod's scope is quite extensive, touching many aspect of the base game. Since this mod is a one man's work, developed on my free time between school hours, I haven't been able to extensively test all its aspects, most notably its compatibility with other mods and DLC. I therefore expect some bugs and compatibility issues (hopefully nothing game-breaking) to be found and reported.

Note that i decided to release this mod even though moves and legendary quests could use some improvement, but I currently have a lot of projects for school and exams are approaching, so i decided to release now and let you enjoy PokéWorld despite it not beeing fully finished, so as to not make you wait several more month.

My first objective after release will be to fix most of these bugs and compatibility issues before adding new content. If you do find a bug, please report it so that i may fix it. I could have spent more time testing, but this would mean pushing the release further and further, instead of letting the community enjoy my work.

Please use with caution and not with a save you care a lot about, I advise creating a new game for this mod with small or QoL mods until it has been tested further.

Feel free to give your feedback (positive or negative) and share this mod with other fans of Pokémon and RimWorld alike.
